aubio 0.4.2~alpha

- Main Page
- Data Structures
- Files
- Examples

- File List
- Globals

tss.h
Go to the documentation of this file.
1 /*
2 Copyright (C) 2003-2013 Paul Brossier <piem@aubio.org>
3
4 This file is part of aubio.
5
6 aubio is free software: you can redistribute it and/or modify
7 it under the terms of the GNU General Public License as published by
8 the Free Software Foundation, either version 3 of the License, or
9 (at your option) any later version.
10
11 aubio is distributed in the hope that it will be useful,
12 but WITHOUT ANY WARRANTY; without even the implied warranty of
13 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 GNU General Public License for more details.
15
16 You should have received a copy of the GNU General Public License
17 along with aubio. If not, see <http://www.gnu.org/licenses/>.
18
19 */
20
21 /** \file
22
23 Transient / Steady-state Separation (TSS)
24
25 This file implement a Transient / Steady-state Separation (TSS) as described
26 in:
27
28 Christopher Duxbury, Mike E. Davies, and Mark B. Sandler. Separation of
29 transient information in musical audio using multiresolution analysis
30 techniques. In Proceedings of the Digital Audio Effects Conference, DAFx-01,
31 pages 1--5, Limerick, Ireland, 2001.
32
33 Available at http://www.csis.ul.ie/dafx01/proceedings/papers/duxbury.pdf
34
35 \example spectral/test-tss.c
36
37 */
38
39 #ifndef _AUBIO_TSS_H
40 #define _AUBIO_TSS_H
41
42 #ifdef __cplusplus
43 extern "C" {
44 #endif
45
46 /** Transient / Steady-state Separation object */
47 typedef struct _aubio_tss_t aubio_tss_t;
48
49 /** create tss object
50
51 \param buf_size buffer size
52 \param hop_size step size
53
54 */
55 aubio_tss_t *new_aubio_tss (uint_t buf_size, uint_t hop_size);
56
57 /** delete tss object
58
59 \param o tss object as returned by new_aubio_tss()
60
61 */
62 void del_aubio_tss (aubio_tss_t * o);
63
64 /** split input into transient and steady states components
65
66 \param o tss object as returned by new_aubio_tss()
67 \param input input spectral frame
68 \param trans output transient components
69 \param stead output steady state components
70
71 */
72 void aubio_tss_do (aubio_tss_t * o, cvec_t * input, cvec_t * trans,
73 cvec_t * stead);
74
75 /** set transient / steady state separation threshold
76
77 \param o tss object as returned by new_aubio_tss()
78 \param thrs new threshold value
79
80 */
81 uint_t aubio_tss_set_threshold (aubio_tss_t * o, smpl_t thrs);
82
83 /** set parameter a, defaults to 3
84
85 \param o tss object as returned by new_aubio_tss()
86 \param alpha new value for alpha parameter
87
88 */
89 uint_t aubio_tss_set_alpha (aubio_tss_t * o, smpl_t alpha);
90
91 /** set parameter b, defaults to 3
92
93 \param o tss object as returned by new_aubio_tss()
94 \param beta new value for beta parameter
95
96 */
97 uint_t aubio_tss_set_beta (aubio_tss_t * o, smpl_t beta);
98
99 #ifdef __cplusplus
100 }
101 #endif
102
103 #endif /* _AUBIO_TSS_H */
aubio_tss_do
void aubio_tss_do(aubio_tss_t *o, cvec_t *input, cvec_t *trans, cvec_t *stead)
split input into transient and steady states components
smpl_t
float smpl_t
short sample format (32 or 64 bits)
Definition: types.h:41
del_aubio_tss
void del_aubio_tss(aubio_tss_t *o)
delete tss object
aubio_tss_set_beta
uint_t aubio_tss_set_beta(aubio_tss_t *o, smpl_t beta)
set parameter b, defaults to 3
aubio_tss_t
struct _aubio_tss_t aubio_tss_t
Transient / Steady-state Separation object.
Definition: tss.h:47
new_aubio_tss
aubio_tss_t * new_aubio_tss(uint_t buf_size, uint_t hop_size)
create tss object
cvec_t
Vector of real-valued phase and spectrum data.
Definition: cvec.h:63
uint_t
unsigned int uint_t
unsigned integer
Definition: types.h:60
aubio_tss_set_threshold
uint_t aubio_tss_set_threshold(aubio_tss_t *o, smpl_t thrs)
set transient / steady state separation threshold
aubio_tss_set_alpha
uint_t aubio_tss_set_alpha(aubio_tss_t *o, smpl_t alpha)
set parameter a, defaults to 3